<?
//============================================================================================
// adduser.php - (c) V1.0  Tim Henderson  Web-Bureau.com 2003
//--------------------------------------------------------------------------------------------
// Ths script is triggered by ipn.php - The PayPal Instant Payment Notification Script.
// Whan a payment notification is received from PayPal (or any processor!)...
//-------------------------------------------------------------------------------------------
// This fine script is offered as CONTRIBUTION-WARE:  
//    - For personal use, send me an email and let me know how you get on!
//    - For commercial use, make a donation - the amount is up to you!
//--------------------------------------------------------------------------------------------
// To contribute to The Webmaster's Bureau, or pay for commercial usage of this script see:
// http://web-bureau.com/contribute.php
//============================================================================================
// 1) Adds new users to the DB.
// 2) Updates existing subscribers info.
// 3) Sends lessons in email attachments to the subscriber.
//-----------------------------------------------------------------------------------------------------
// This script is based on the model The Web-Bureau was originally intened to follow - a subscriptions
// model. This may be implemented in the future, but for now - it's free!
// You will probably need to modify this code for your own particular model. My assistance is cheap!
//-----------------------------------------------------------------------------------------------------

//-----------------------------
// RELATED DATABASE TABLES: 
//-----------------------------
/*
CREATE TABLE wbusers (
  u_id         INT UNSIGNED AUTO_INCREMENT,
  txn_id       VARCHAR(20),
  updated      TIMESTAMP,
  joined       TIMESTAMP,
  pid          VARCHAR(10),
  name         VARCHAR(60),
  email        VARCHAR(60),
  password     VARCHAR(10),
  url          VARCHAR(100),
  lesson       INT UNSIGNED DEFAULT 1,
  status       CHAR(1) DEFAULT 'A',
  PRIMARY KEY (u_id)
);

CREATE TABLE payments (
  txn_id       VARCHAR(20) NOT NULL,
  email        VARCHAR(60),
  name         VARCHAR(60),
  updated      TIMESTAMP,
  pid          VARCHAR(10),
  PRIMARY KEY (txn_id)
);

CREATE TABLE errors (
  e_id         INT UNSIGNED AUTO_INCREMENT,
  created      TIMESTAMP,
  msg          VARCHAR(255),
  PRIMARY KEY (e_id)
);
-----------------*/

//--------------------------------------------------------------------------------------
// A basic security measure - to hinder someone triggering the adduser script
// by just typing the right parameters into their browser is to pass this check value:
//---------------------------------------------------------------------------------------
if ($chk="chkcode") {
  //------------------------
  // Open DB Connection.
  //------------------------
  $db_user        = "user";
  $db_passwd      = "passwd";
  $db_name        = "db";
  $db = mysql_connect("localhost", $db_user, $db_passwd); 
  mysql_select_db($db_name,$db);

  //-----------------------------------------------------------------------------------
  // include Mime Mail class - we'll use this to send mail with attachments later...
  // Note, mmail.php is a 3rd party free script.
  //-----------------------------------------------------------------------------------
  include ("mmail.php");

  //--------------------------------------------------------------------------------
  // Basic DEBUG message... 
  // This won't get show if it's run by ipn.php - because that script was triggered 
  // by PayPal and has no output. If you change it and need to debug it though, you 
  // can just run it in a browser window.
  //--------------------------------------------------------------------------------
  echo "AddUser...<br><br>TXID:$txn_id  TYPE:$txn_type  NAME:$name  EMAIL:$email  PRODUCT:$pid<br><br>";

  //=======================================================================================
  // You can do anything when this script is triggered, you'll certainly want to add the 
  // user to your database. This script was written with PayPal subscriptions in mind and
  // handles sending the lessons of the course out when each payment is received.
  //=======================================================================================

  //--------------------------------------------------------------------------------
  // We're only interested in 2 txn_types: subscr_payment and subscr_cancel.
  //--------------------------------------------------------------------------------
  if (strcmp($txn_type, "subscr_payment") == 0) ) {

    //-------------------------------------------------------------------
    // See if user is already registered: get user_id by email addr...
    //-------------------------------------------------------------------
    $qry = "SELECT u_id FROM wbusers WHERE email=\"$email\"";
    $result = mysql_query($qry, $db);
    while ($myrow = mysql_fetch_row($result)) { $u_id = $myrow[0]; }

    //--------------------------------
    // If email Addr already used...
    //--------------------------------
    if (mysql_num_rows($result) > 0) {
      //echo "User: $u_id already exists \n";

      //--------------------------------------------
      // Get current lesson number for this user.
      //--------------------------------------------
      $qry = "SELECT lesson FROM wbusers WHERE u_id=$u_id";
      $result = mysql_query($qry, $db);
      while ($myrow = mysql_fetch_row($result)) { $lesson = $myrow[0]; }
      if (mysql_num_rows($result) != 1) {
        //-------------------------------------------------
        // All errors are written in to the errors table.
        //-------------------------------------------------
        $qry = "INSERT INTO errors (msg) ";
        $qry = $qry. "VALUES (\"Lesson Select Failed: ". mysql_error(). "\")";
        $result = mysql_query($qry, $db);
        }
      //------------------------------------------
      // Increment and Update the lesson number.
      //------------------------------------------
      $qry = "UPDATE wbusers SET lesson=lesson+1 WHERE u_id=$u_id";
      $result = mysql_query($qry, $db);
      $lesson = $lesson + 1;
      }

    //-------------------------------------------------------------
    // Else it's a new registration...
    //-------------------------------------------------------------
    else {
      $lesson = 1;
      //------------------------------------------------------------
      // Set the new user's initial status...
      // Status: (S)ubscribe   (P)aid   (G)raduate   (C)ancelled...
      //------------------------------------------------------------
      if (strcmp($txn_type, "subscr_payment") == 0) { $status='S'; }
      else { $status='P'; }

      //--------------------------------
      // Add new user to wbusers table
      //--------------------------------
      $qry = "INSERT INTO wbusers (txn_id, name, email, password, joined, pid, status) ";
      $qry = $qry. "VALUES (\"$txn_id\", \"$name\", \"$email\", \"$password\", now(), \"$pid\", \"$status\")";
      $result = mysql_query($qry, $db);
      if ($result != 1) {
        $qry = "INSERT INTO errors (msg) ";
        $qry = $qry. "VALUES (\"User Insert Failed: ". mysql_error(). "\")";
        $result = mysql_query($qry, $db);
        $message .= "Dear $name,\n There has been an error processing your application. This has been noted and will be processed by hand as soon as possible.\n\n We apologise for any inconvenience.\n\nIf you don't hear anything within 48 Hours, please contact us: \n\ninfo@web-bureau.com";
        mail ($payer_email, "Message from The Webmaster's Bureau...", $message, "From: info@web-bureau.com\nReply-To: info@web-bureau.com");
        }
      }

    //---------------------------------
    // Add all payment details to DB
    //---------------------------------
    $qry = "INSERT INTO payments (txn_id, name, email, pid) VALUES (\"$txn_id\", \"$name\", \"$email\", \"$pid\")";
    $result = mysql_query($qry, $db);
    if ($result != 1) {
      $qry = "INSERT INTO errors (msg) VALUES (\"Payment Insert Failed: ". mysql_error(). "\")";
      $result = mysql_query($qry, $db);
      }

    //------------------------------------------------------------------------------------------
    // The Webmaster's Bureau lessons were originally sent out as ebooks attached to an email.
    // Send The Lessons... You can attach any number of files to an email!
    //------------------------------------------------------------------------------------------
    if ($lesson == 1) {
      $attachment    = fread(fopen("./lessons/wb-L1.zip", "r"), filesize("./lessons/wb-L1.zip"));
      $mail          = new mime_mail();
      $mail->from    = "info@web-bureau.com";
      $mail->headers = "Reply-To: info@web-bureau.com";
      $mail->to      = $email;
      $mail->subject = "Lesson 1.";
      $mail->body    = fread(fopen("./lessons/L1.txt", "r"), filesize("./lessons/L1.txt")); 
      $mail->add_attachment("$attachment", "wb-L1.zip");
      $mail->send();

      $attachment    = fread(fopen("./lessons/magicletters.zip", "r"), filesize("./lessons/magicletters.zip"));
      $mail          = new mime_mail();
      $mail->from    = "info@web-bureau.com";
      $mail->headers = "Reply-To: info@web-bureau.com";
      $mail->to      = $email;
      $mail->subject = "Bonus: MagicLetters.zip.";
      $mail->body    = fread(fopen("./lessons/L1b.txt", "r"), filesize("./lessons/L1b.txt")); 
      $mail->add_attachment("$attachment", "magicletters.zip");
      $mail->send();
      }
    //------------------------------
    // Lesson 2... blah blah...
    //------------------------------
    // and so on...
    }

  //---------------------------------------------------
  // CANCEL SUBSCRIPTION - Change user status...
  // Send an email, request feedback from customer...
  //---------------------------------------------------
  elseif (strcmp($txn_type, "subscr_cancel") == 0) {
    echo "Cancel Subscription<br><br>";
    $message .= "Dear $name,\n Your subscription has been cancelled.\n\nThankyou for trying the course, we're sorry you feel it didn't provide what you wanted.\n\nIn order to improve service to our customers, we'd really appreciate any feedback.\n\nBest Regards.";
    mail ($email, "Cancellation...", $message, "From: info@yourdomain.com\nReply-To: info@yourdomain.com");
    $qry = "UPDATE wbusers SET status=\"C\" WHERE email = \"$email\" ";
    $result = mysql_query($qry, $db);
    if ($result != 1) {
      $qry = "INSERT INTO errors (msg) ";
      $qry = $qry. "VALUES (\"User Cancel Failed: ". mysql_error(). "\")";
      $result = mysql_query($qry, $db);
      }
    }
  mysql_close($db);
  }
?>